'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _plurallIcons = require('plurall-icons');

var _style3 = require('./style');

var _style4 = _interopRequireDefault(_style3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

    _this.state = {};

    _this.collapse = function (event) {
      if (event && event.target && !event.target.getAttribute('data-plurall-dropdown')) {
        _this.setState({ open: false });
      }
    };

    _this.handleChange = function (option) {
      _this.setState({ open: false });

      var onChange = _this.props.onChange;


      if (onChange) {
        onChange(option.value);
      }
    };

    _this.handleToggle = function () {
      return _this.setState(function (_ref) {
        var open = _ref.open;
        return { open: !open };
      });
    };

    _this.isOptionSelected = function (option) {
      var selected = _this.props.selected;


      return option.value === selected;
    };

    _this.renderOption = function (option) {
      return _react2.default.createElement(
        'li',
        {
          key: option.value,
          role: 'presentation',

          onMouseDown: function onMouseDown() {
            return _this.handleChange(option);
          },
          className: 'jsx-' + _style3.option.__hash + ' ' + ((0, _classnames2.default)('option', { selected: _this.isOptionSelected(option) }) || '')
        },
        option.label,
        _react2.default.createElement(
          _style2.default,
          {
            id: _style3.option.__hash
          },
          _style3.option
        )
      );
    };

    _this.body = document.body;
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.body.addEventListener('click', this.collapse);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.body.removeEventListener('click', this.collapse);
    }
  }, {
    key: 'render',
    value: function render() {
      var handleToggle = this.handleToggle,
          isOptionSelected = this.isOptionSelected,
          options = this.props.options,
          renderOption = this.renderOption,
          open = this.state.open;


      var selectedOption = options.find(isOptionSelected);
      var value = selectedOption ? selectedOption.label : options[0].label;
      var className = (0, _classnames2.default)('dropdown', { open: open });

      return _react2.default.createElement(
        'div',
        { 'data-plurall-dropdown': 'true',
          onClick: handleToggle, className: 'jsx-' + _style4.default.__hash + ' ' + (className || '')
        },
        _react2.default.createElement('input', {
          value: value,
          readOnly: true,
          'data-plurall-dropdown': 'true',
          className: 'jsx-' + _style4.default.__hash + ' ' + 'input'
        }),
        _react2.default.createElement(
          'div',
          { 'data-plurall-dropdown': 'true', className: 'jsx-' + _style4.default.__hash + ' ' + 'arrowIcon'
          },
          _react2.default.createElement(_plurallIcons.PureArrow, { 'data-plurall-dropdown': 'true', size: 12 })
        ),
        open && _react2.default.createElement(
          'div',
          {
            className: 'jsx-' + _style4.default.__hash + ' ' + 'optionsWrapper'
          },
          _react2.default.createElement(
            'ul',
            {
              className: 'jsx-' + _style4.default.__hash + ' ' + 'options'
            },
            options.map(renderOption)
          )
        ),
        _react2.default.createElement(
          _style2.default,
          {
            id: _style4.default.__hash
          },
          _style4.default
        )
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.valueProps = _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired;
Dropdown.optionProps = _propTypes2.default.arrayOf(_propTypes2.default.shape({
  value: Dropdown.valueProps,
  label: _propTypes2.default.string
})).isRequired;
Dropdown.propTypes = {
  options: Dropdown.optionProps,
  selected: Dropdown.valueProps,
  onChange: _propTypes2.default.func
};
exports.default = Dropdown;